Index: lemon/connectivity.h
===================================================================
--- lemon/connectivity.h	(revision 578)
+++ lemon/connectivity.h	(revision 550)
@@ -33,5 +33,5 @@
 #include <functional>
 
-/// \ingroup graph_properties
+/// \ingroup connectivity
 /// \file
 /// \brief Connectivity algorithms
@@ -41,5 +41,5 @@
 namespace lemon {
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check whether the given undirected graph is connected.
@@ -64,5 +64,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the number of connected components of an undirected graph
@@ -106,12 +106,9 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the connected components of an undirected graph
   ///
   /// Find the connected components of an undirected graph.
-  ///
-  /// \image html connected_components.png
-  /// \image latex connected_components.eps "Connected components" width=\textwidth
   ///
   /// \param graph The graph. It must be undirected.
@@ -121,4 +118,5 @@
   /// set continuously.
   /// \return The number of components
+  ///
   template <class Graph, class NodeMap>
   int connectedComponents(const Graph &graph, NodeMap &compMap) {
@@ -230,5 +228,5 @@
 
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check whether the given directed graph is strongly connected.
@@ -288,5 +286,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the strongly connected components of a directed graph
@@ -352,5 +350,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the strongly connected components of a directed graph
@@ -364,7 +362,4 @@
   /// a lower.
   ///
-  /// \image html strongly_connected_components.png
-  /// \image latex strongly_connected_components.eps "Strongly connected components" width=\textwidth
-  ///
   /// \param digraph The digraph.
   /// \retval compMap A writable node map. The values will be set from 0 to
@@ -373,4 +368,5 @@
   /// will be set continuously.
   /// \return The number of components
+  ///
   template <typename Digraph, typename NodeMap>
   int stronglyConnectedComponents(const Digraph& digraph, NodeMap& compMap) {
@@ -421,5 +417,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the cut arcs of the strongly connected components.
@@ -705,5 +701,5 @@
   int countBiNodeConnectedComponents(const Graph& graph);
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Checks the graph is bi-node-connected.
@@ -720,5 +716,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the biconnected components.
@@ -755,5 +751,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-node-connected components.
@@ -763,7 +759,4 @@
   /// relation on the undirected edges. Two undirected edge are in relationship
   /// when they are on same circle.
-  ///
-  /// \image html node_biconnected_components.png
-  /// \image latex node_biconnected_components.eps "bi-node-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -773,4 +766,5 @@
   /// will be set continuously.
   /// \return The number of components.
+  ///
   template <typename Graph, typename EdgeMap>
   int biNodeConnectedComponents(const Graph& graph,
@@ -800,5 +794,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-node-connected cut nodes.
@@ -1030,5 +1024,5 @@
   int countBiEdgeConnectedComponents(const Graph& graph);
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Checks that the graph is bi-edge-connected.
@@ -1045,5 +1039,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the bi-edge-connected components.
@@ -1080,5 +1074,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-edge-connected components.
@@ -1088,7 +1082,4 @@
   /// relation on the nodes. Two nodes are in relationship when they are
   /// connected at least two edge-disjoint paths.
-  ///
-  /// \image html edge_biconnected_components.png
-  /// \image latex edge_biconnected_components.eps "bi-edge-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -1098,4 +1089,5 @@
   /// will be set continuously.
   /// \return The number of components.
+  ///
   template <typename Graph, typename NodeMap>
   int biEdgeConnectedComponents(const Graph& graph, NodeMap& compMap) {
@@ -1124,5 +1116,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-edge-connected cut edges.
@@ -1188,5 +1180,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1227,5 +1219,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1282,5 +1274,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given directed graph is a DAG.
@@ -1324,5 +1316,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given undirected graph is acyclic.
@@ -1358,5 +1350,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given undirected graph is tree.
@@ -1450,5 +1442,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1487,5 +1479,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1495,8 +1487,4 @@
   /// During the execution, the \c partMap will be set as the two
   /// partitions of the graph.
-  ///
-  /// \image html bipartite_partitions.png
-  /// \image latex bipartite_partitions.eps "Bipartite partititions" width=\textwidth
-  ///
   /// \param graph The undirected graph.
   /// \retval partMap A writable bool map of nodes. It will be set as the
Index: lemon/core.h
===================================================================
--- lemon/core.h	(revision 573)
+++ lemon/core.h	(revision 550)
@@ -1316,5 +1316,5 @@
     virtual void clear() {
       for(NodeIt n(_g);n!=INVALID;++n) {
-        _head[n] = INVALID;
+        _head.set(n, INVALID);
       }
     }
@@ -1323,11 +1323,11 @@
       Node s = _g.source(arc);
       Node t = _g.target(arc);
-      _left[arc] = INVALID;
-      _right[arc] = INVALID;
+      _left.set(arc, INVALID);
+      _right.set(arc, INVALID);
 
       Arc e = _head[s];
       if (e == INVALID) {
-        _head[s] = arc;
-        _parent[arc] = INVALID;
+        _head.set(s, arc);
+        _parent.set(arc, INVALID);
         return;
       }
@@ -1335,6 +1335,6 @@
         if (t < _g.target(e)) {
           if (_left[e] == INVALID) {
-            _left[e] = arc;
-            _parent[arc] = e;
+            _left.set(e, arc);
+            _parent.set(arc, e);
             splay(arc);
             return;
@@ -1344,6 +1344,6 @@
         } else {
           if (_right[e] == INVALID) {
-            _right[e] = arc;
-            _parent[arc] = e;
+            _right.set(e, arc);
+            _parent.set(arc, e);
             splay(arc);
             return;
@@ -1358,25 +1358,25 @@
       if (_left[arc] == INVALID) {
         if (_right[arc] != INVALID) {
-          _parent[_right[arc]] = _parent[arc];
+          _parent.set(_right[arc], _parent[arc]);
         }
         if (_parent[arc] != INVALID) {
           if (_left[_parent[arc]] == arc) {
-            _left[_parent[arc]] = _right[arc];
+            _left.set(_parent[arc], _right[arc]);
           } else {
-            _right[_parent[arc]] = _right[arc];
+            _right.set(_parent[arc], _right[arc]);
           }
         } else {
-          _head[_g.source(arc)] = _right[arc];
+          _head.set(_g.source(arc), _right[arc]);
         }
       } else if (_right[arc] == INVALID) {
-        _parent[_left[arc]] = _parent[arc];
+        _parent.set(_left[arc], _parent[arc]);
         if (_parent[arc] != INVALID) {
           if (_left[_parent[arc]] == arc) {
-            _left[_parent[arc]] = _left[arc];
+            _left.set(_parent[arc], _left[arc]);
           } else {
-            _right[_parent[arc]] = _left[arc];
+            _right.set(_parent[arc], _left[arc]);
           }
         } else {
-          _head[_g.source(arc)] = _left[arc];
+          _head.set(_g.source(arc), _left[arc]);
         }
       } else {
@@ -1388,36 +1388,36 @@
           }
           Arc s = _parent[e];
-          _right[_parent[e]] = _left[e];
+          _right.set(_parent[e], _left[e]);
           if (_left[e] != INVALID) {
-            _parent[_left[e]] = _parent[e];
+            _parent.set(_left[e], _parent[e]);
           }
 
-          _left[e] = _left[arc];
-          _parent[_left[arc]] = e;
-          _right[e] = _right[arc];
-          _parent[_right[arc]] = e;
-
-          _parent[e] = _parent[arc];
+          _left.set(e, _left[arc]);
+          _parent.set(_left[arc], e);
+          _right.set(e, _right[arc]);
+          _parent.set(_right[arc], e);
+
+          _parent.set(e, _parent[arc]);
           if (_parent[arc] != INVALID) {
             if (_left[_parent[arc]] == arc) {
-              _left[_parent[arc]] = e;
+              _left.set(_parent[arc], e);
             } else {
-              _right[_parent[arc]] = e;
+              _right.set(_parent[arc], e);
             }
           }
           splay(s);
         } else {
-          _right[e] = _right[arc];
-          _parent[_right[arc]] = e;
-          _parent[e] = _parent[arc];
+          _right.set(e, _right[arc]);
+          _parent.set(_right[arc], e);
+          _parent.set(e, _parent[arc]);
 
           if (_parent[arc] != INVALID) {
             if (_left[_parent[arc]] == arc) {
-              _left[_parent[arc]] = e;
+              _left.set(_parent[arc], e);
             } else {
-              _right[_parent[arc]] = e;
+              _right.set(_parent[arc], e);
             }
           } else {
-            _head[_g.source(arc)] = e;
+            _head.set(_g.source(arc), e);
           }
         }
@@ -1431,15 +1431,15 @@
       if (a < m) {
         Arc left = refreshRec(v,a,m-1);
-        _left[me] = left;
-        _parent[left] = me;
+        _left.set(me, left);
+        _parent.set(left, me);
       } else {
-        _left[me] = INVALID;
+        _left.set(me, INVALID);
       }
       if (m < b) {
         Arc right = refreshRec(v,m+1,b);
-        _right[me] = right;
-        _parent[right] = me;
+        _right.set(me, right);
+        _parent.set(right, me);
       } else {
-        _right[me] = INVALID;
+        _right.set(me, INVALID);
       }
       return me;
@@ -1453,8 +1453,8 @@
           std::sort(v.begin(),v.end(),ArcLess(_g));
           Arc head = refreshRec(v,0,v.size()-1);
-          _head[n] = head;
-          _parent[head] = INVALID;
-        }
-        else _head[n] = INVALID;
+          _head.set(n, head);
+          _parent.set(head, INVALID);
+        }
+        else _head.set(n, INVALID);
       }
     }
@@ -1462,17 +1462,17 @@
     void zig(Arc v) {
       Arc w = _parent[v];
-      _parent[v] = _parent[w];
-      _parent[w] = v;
-      _left[w] = _right[v];
-      _right[v] = w;
+      _parent.set(v, _parent[w]);
+      _parent.set(w, v);
+      _left.set(w, _right[v]);
+      _right.set(v, w);
       if (_parent[v] != INVALID) {
         if (_right[_parent[v]] == w) {
-          _right[_parent[v]] = v;
+          _right.set(_parent[v], v);
         } else {
-          _left[_parent[v]] = v;
+          _left.set(_parent[v], v);
         }
       }
       if (_left[w] != INVALID){
-        _parent[_left[w]] = w;
+        _parent.set(_left[w], w);
       }
     }
@@ -1480,17 +1480,17 @@
     void zag(Arc v) {
       Arc w = _parent[v];
-      _parent[v] = _parent[w];
-      _parent[w] = v;
-      _right[w] = _left[v];
-      _left[v] = w;
+      _parent.set(v, _parent[w]);
+      _parent.set(w, v);
+      _right.set(w, _left[v]);
+      _left.set(v, w);
       if (_parent[v] != INVALID){
         if (_left[_parent[v]] == w) {
-          _left[_parent[v]] = v;
+          _left.set(_parent[v], v);
         } else {
-          _right[_parent[v]] = v;
+          _right.set(_parent[v], v);
         }
       }
       if (_right[w] != INVALID){
-        _parent[_right[w]] = w;
+        _parent.set(_right[w], w);
       }
     }
Index: lemon/cplex.cc
===================================================================
--- lemon/cplex.cc	(revision 568)
+++ lemon/cplex.cc	(revision 540)
@@ -73,5 +73,4 @@
     int status;
     _prob = CPXcreateprob(cplexEnv(), &status, "Cplex problem");
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -80,5 +79,4 @@
     int status;
     _prob = CPXcreateprob(cplexEnv(), &status, "Cplex problem");
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -89,5 +87,4 @@
     rows = cplex.rows;
     cols = cplex.cols;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -440,23 +437,4 @@
     rows.clear();
     cols.clear();
-  }
-
-  void CplexBase::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_enabled = false;
-      break;
-    case MESSAGE_ERROR:
-    case MESSAGE_WARNING:
-    case MESSAGE_NORMAL:
-    case MESSAGE_VERBOSE:
-      _message_enabled = true;
-      break;
-    }
-  }
-
-  void CplexBase::_applyMessageLevel() {
-    CPXsetintparam(cplexEnv(), CPX_PARAM_SCRIND, 
-                   _message_enabled ? CPX_ON : CPX_OFF);
   }
 
@@ -530,5 +508,4 @@
   CplexLp::SolveExitStatus CplexLp::_solve() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXlpopt(cplexEnv(), _prob));
   }
@@ -536,5 +513,4 @@
   CplexLp::SolveExitStatus CplexLp::solvePrimal() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXprimopt(cplexEnv(), _prob));
   }
@@ -542,5 +518,4 @@
   CplexLp::SolveExitStatus CplexLp::solveDual() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXdualopt(cplexEnv(), _prob));
   }
@@ -548,5 +523,4 @@
   CplexLp::SolveExitStatus CplexLp::solveBarrier() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXbaropt(cplexEnv(), _prob));
   }
@@ -627,5 +601,5 @@
   }
 
-  // Cplex 7.0 status values
+  //7.5-os cplex statusai (Vigyazat: a 9.0-asei masok!)
   // This table lists the statuses, returned by the CPXgetstat()
   // routine, for solutions to LP problems or mixed integer problems. If
@@ -674,5 +648,5 @@
   //       User pivot used
   //
-  // Pending return values
+  //     Ezeket hova tegyem:
   // ??case CPX_ABORT_DUAL_INFEAS
   // ??case CPX_ABORT_CROSSOVER
@@ -745,4 +719,5 @@
     statusSwitch(cplexEnv(),stat);
     //CPXgetstat(cplexEnv(), _prob);
+    //printf("A primal status: %d, CPX_OPTIMAL=%d \n",stat,CPX_OPTIMAL);
     switch (stat) {
     case 0:
@@ -777,5 +752,5 @@
   }
 
-  // Cplex 9.0 status values
+  //9.0-as cplex verzio statusai
   // CPX_STAT_ABORT_DUAL_OBJ_LIM
   // CPX_STAT_ABORT_IT_LIM
@@ -890,5 +865,4 @@
   CplexMip::SolveExitStatus CplexMip::_solve() {
     int status;
-    _applyMessageLevel();
     status = CPXmipopt (cplexEnv(), _prob);
     if (status==0)
Index: lemon/cplex.h
===================================================================
--- lemon/cplex.h	(revision 568)
+++ lemon/cplex.h	(revision 540)
@@ -145,27 +145,12 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel level);
-    void _applyMessageLevel();
-
-    bool _message_enabled;
-
   public:
 
     /// Returns the used \c CplexEnv instance
     const CplexEnv& env() const { return _env; }
-
-    /// \brief Returns the const cpxenv pointer
     ///
-    /// \note The cpxenv might be destructed with the solver.
     const cpxenv* cplexEnv() const { return _env.cplexEnv(); }
 
-    /// \brief Returns the const cpxenv pointer
-    ///
-    /// \note The cpxenv might be destructed with the solver.
-    cpxenv* cplexEnv() { return _env.cplexEnv(); }
-
-    /// Returns the cplex problem object
     cpxlp* cplexLp() { return _prob; }
-    /// Returns the cplex problem object
     const cpxlp* cplexLp() const { return _prob; }
 
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 576)
+++ lemon/dfs.h	(revision 519)
@@ -207,5 +207,5 @@
     typedef Dfs Create;
 
-    ///\name Named Template Parameters
+    ///\name Named template parameters
 
     ///@{
Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 576)
+++ lemon/dijkstra.h	(revision 550)
@@ -287,5 +287,5 @@
     typedef Dijkstra Create;
 
-    ///\name Named Template Parameters
+    ///\name Named template parameters
 
     ///@{
Index: lemon/dimacs.h
===================================================================
--- lemon/dimacs.h	(revision 576)
+++ lemon/dimacs.h	(revision 552)
@@ -38,14 +38,9 @@
   struct DimacsDescriptor
   {
-    ///\brief DIMACS file type enum
-    ///
-    ///DIMACS file type enum.
-    enum Type {
-      NONE,  ///< Undefined type.
-      MIN,   ///< DIMACS file type for minimum cost flow problems.
-      MAX,   ///< DIMACS file type for maximum flow problems.
-      SP,    ///< DIMACS file type for shostest path problems.
-      MAT    ///< DIMACS file type for plain graphs and matching problems.
-    };
+    ///File type enum
+    enum Type
+      {
+        NONE, MIN, MAX, SP, MAT
+      };
     ///The file type
     Type type;
@@ -55,5 +50,5 @@
     int edgeNum;
     int lineShift;
-    ///Constructor. It sets the type to \c NONE.
+    /// Constructor. Sets the type to NONE.
     DimacsDescriptor() : type(NONE) {}
   };
@@ -61,8 +56,8 @@
   ///Discover the type of a DIMACS file
 
-  ///This function starts seeking the beginning of the given file for the
-  ///problem type and size info. 
-  ///The found data is returned in a special struct that can be evaluated
-  ///and passed to the appropriate reader function.
+  ///It starts seeking the beginning of the file for the problem type
+  ///and size info. The found data is returned in a special struct
+  ///that can be evaluated and passed to the appropriate reader
+  ///function.
   DimacsDescriptor dimacsType(std::istream& is)
   {
@@ -102,5 +97,6 @@
 
 
-  /// \brief DIMACS minimum cost flow reader function.
+
+  /// DIMACS minimum cost flow reader function.
   ///
   /// This function reads a minimum cost flow instance from DIMACS format,
@@ -258,5 +254,5 @@
   }
 
-  /// \brief DIMACS maximum flow reader function.
+  /// DIMACS maximum flow reader function.
   ///
   /// This function reads a maximum flow instance from DIMACS format,
@@ -292,5 +288,5 @@
   }
 
-  /// \brief DIMACS shortest path reader function.
+  /// DIMACS shortest path reader function.
   ///
   /// This function reads a shortest path instance from DIMACS format,
@@ -318,5 +314,5 @@
   }
 
-  /// \brief DIMACS capacitated digraph reader function.
+  /// DIMACS capacitated digraph reader function.
   ///
   /// This function reads an arc capacitated digraph instance from
@@ -364,9 +360,9 @@
   }
   
-  /// \brief DIMACS plain (di)graph reader function.
-  ///
-  /// This function reads a plain (di)graph without any designated nodes
-  /// and maps (e.g. a matching instance) from DIMACS format, i.e. from 
-  /// DIMACS files having a line starting with
+  /// DIMACS plain (di)graph reader function.
+  ///
+  /// This function reads a (di)graph without any designated nodes and
+  /// maps from DIMACS format, i.e. from DIMACS files having a line
+  /// starting with
   /// \code
   ///   p mat
Index: lemon/elevator.h
===================================================================
--- lemon/elevator.h	(revision 573)
+++ lemon/elevator.h	(revision 550)
@@ -77,5 +77,5 @@
     void copy(Item i, Vit p)
     {
-      _where[*p=i] = p;
+      _where.set(*p=i,p);
     }
     void copy(Vit s, Vit p)
@@ -85,5 +85,5 @@
           Item i=*s;
           *p=i;
-          _where[i] = p;
+          _where.set(i,p);
         }
     }
@@ -92,6 +92,6 @@
       Item ti=*i;
       Vit ct = _where[ti];
-      _where[ti] = _where[*i=*j];
-      _where[*j] = ct;
+      _where.set(ti,_where[*i=*j]);
+      _where.set(*j,ct);
       *j=ti;
     }
@@ -227,5 +227,5 @@
     {
       Item it = *_last_active[_highest_active];
-      ++_level[it];
+      _level.set(it,_level[it]+1);
       swap(_last_active[_highest_active]--,_last_active[_highest_active+1]);
       --_first[++_highest_active];
@@ -250,5 +250,5 @@
         }
       copy(li,_first[new_level]);
-      _level[li] = new_level;
+      _level.set(li,new_level);
       _highest_active=new_level;
     }
@@ -270,5 +270,5 @@
       copy(li,_first[_max_level]);
       --_last_active[_max_level];
-      _level[li] = _max_level;
+      _level.set(li,_max_level);
 
       while(_highest_active>=0 &&
@@ -300,5 +300,5 @@
     {
       Item it =*_last_active[level];
-      ++_level[it];
+      _level.set(it,_level[it]+1);
       swap(_last_active[level]--, --_first[level+1]);
       if (level+1>_highest_active) ++_highest_active;
@@ -320,5 +320,5 @@
         }
       copy(ai,_first[new_level]);
-      _level[ai] = new_level;
+      _level.set(ai,new_level);
       if (new_level>_highest_active) _highest_active=new_level;
     }
@@ -340,5 +340,5 @@
       copy(ai,_first[_max_level]);
       --_last_active[_max_level];
-      _level[ai] = _max_level;
+      _level.set(ai,_max_level);
 
       if (_highest_active==level) {
@@ -371,5 +371,5 @@
         }
       copy(i,_first[new_level]);
-      _level[i] = new_level;
+      _level.set(i,new_level);
       if(new_level>_highest_active) _highest_active=new_level;
     }
@@ -383,5 +383,5 @@
     ///\pre The item is on the top level.
     void dirtyTopButOne(Item i) {
-      _level[i] = _max_level - 1;
+      _level.set(i,_max_level - 1);
     }
 
@@ -395,5 +395,5 @@
       const Vit tl=_first[_max_level];
       for(Vit i=f;i!=tl;++i)
-        _level[*i] = _max_level;
+        _level.set(*i,_max_level);
       for(int i=l;i<=_max_level;i++)
         {
@@ -434,6 +434,6 @@
         {
           *n=i;
-          _where[i] = n;
-          _level[i] = _max_level;
+          _where.set(i,n);
+          _level.set(i,_max_level);
           ++n;
         }
@@ -444,5 +444,5 @@
     {
       swap(_where[i],_init_num);
-      _level[i] = _init_lev;
+      _level.set(i,_init_lev);
       ++_init_num;
     }
@@ -552,5 +552,5 @@
     ///\pre Item \c i shouldn't be active before.
     void activate(Item i) {
-      _active[i] = true;
+      _active.set(i, true);
 
       int level = _level[i];
@@ -561,14 +561,14 @@
       if (_prev[i] == INVALID || _active[_prev[i]]) return;
       //unlace
-      _next[_prev[i]] = _next[i];
+      _next.set(_prev[i], _next[i]);
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = _prev[i];
+        _prev.set(_next[i], _prev[i]);
       } else {
         _last[level] = _prev[i];
       }
       //lace
-      _next[i] = _first[level];
-      _prev[_first[level]] = i;
-      _prev[i] = INVALID;
+      _next.set(i, _first[level]);
+      _prev.set(_first[level], i);
+      _prev.set(i, INVALID);
       _first[level] = i;
 
@@ -580,5 +580,5 @@
     ///\pre Item \c i must be active before.
     void deactivate(Item i) {
-      _active[i] = false;
+      _active.set(i, false);
       int level = _level[i];
 
@@ -587,14 +587,14 @@
 
       //unlace
-      _prev[_next[i]] = _prev[i];
+      _prev.set(_next[i], _prev[i]);
       if (_prev[i] != INVALID) {
-        _next[_prev[i]] = _next[i];
+        _next.set(_prev[i], _next[i]);
       } else {
         _first[_level[i]] = _next[i];
       }
       //lace
-      _prev[i] = _last[level];
-      _next[_last[level]] = i;
-      _next[i] = INVALID;
+      _prev.set(i, _last[level]);
+      _next.set(_last[level], i);
+      _next.set(i, INVALID);
       _last[level] = i;
 
@@ -686,5 +686,5 @@
       Item i = _first[_highest_active];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -692,13 +692,13 @@
         _last[_highest_active] = INVALID;
       }
-      _level[i] = ++_highest_active;
+      _level.set(i, ++_highest_active);
       if (_first[_highest_active] == INVALID) {
         _first[_highest_active] = i;
         _last[_highest_active] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[_highest_active]] = i;
-        _next[i] = _first[_highest_active];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[_highest_active], i);
+        _next.set(i, _first[_highest_active]);
         _first[_highest_active] = i;
       }
@@ -715,5 +715,5 @@
       Item i = _first[_highest_active];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -721,12 +721,12 @@
         _last[_highest_active] = INVALID;
       }
-      _level[i] = _highest_active = new_level;
+      _level.set(i, _highest_active = new_level);
       if (_first[_highest_active] == INVALID) {
         _first[_highest_active] = _last[_highest_active] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[_highest_active]] = i;
-        _next[i] = _first[_highest_active];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[_highest_active], i);
+        _next.set(i, _first[_highest_active]);
         _first[_highest_active] = i;
       }
@@ -739,7 +739,7 @@
     void liftHighestActiveToTop() {
       Item i = _first[_highest_active];
-      _level[i] = _max_level;
+      _level.set(i, _max_level);
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -775,5 +775,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -781,12 +781,12 @@
         _last[l] = INVALID;
       }
-      _level[i] = ++l;
+      _level.set(i, ++l);
       if (_first[l] == INVALID) {
         _first[l] = _last[l] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[l]] = i;
-        _next[i] = _first[l];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[l], i);
+        _next.set(i, _first[l]);
         _first[l] = i;
       }
@@ -804,5 +804,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -810,12 +810,12 @@
         _last[l] = INVALID;
       }
-      _level[i] = l = new_level;
+      _level.set(i, l = new_level);
       if (_first[l] == INVALID) {
         _first[l] = _last[l] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[l]] = i;
-        _next[i] = _first[l];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[l], i);
+        _next.set(i, _first[l]);
         _first[l] = i;
       }
@@ -833,5 +833,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -839,5 +839,5 @@
         _last[l] = INVALID;
       }
-      _level[i] = _max_level;
+      _level.set(i, _max_level);
       if (l == _highest_active) {
         while (_highest_active >= 0 && activeFree(_highest_active))
@@ -857,21 +857,21 @@
     void lift(Item i, int new_level) {
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = _prev[i];
+        _prev.set(_next[i], _prev[i]);
       } else {
         _last[new_level] = _prev[i];
       }
       if (_prev[i] != INVALID) {
-        _next[_prev[i]] = _next[i];
+        _next.set(_prev[i], _next[i]);
       } else {
         _first[new_level] = _next[i];
       }
-      _level[i] = new_level;
+      _level.set(i, new_level);
       if (_first[new_level] == INVALID) {
         _first[new_level] = _last[new_level] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[new_level]] = i;
-        _next[i] = _first[new_level];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[new_level], i);
+        _next.set(i, _first[new_level]);
         _first[new_level] = i;
       }
@@ -889,5 +889,5 @@
     ///\pre The item is on the top level.
     void dirtyTopButOne(Item i) {
-      _level[i] = _max_level - 1;
+      _level.set(i, _max_level - 1);
     }
 
@@ -900,5 +900,5 @@
         Item n = _first[i];
         while (n != INVALID) {
-          _level[n] = _max_level;
+          _level.set(n, _max_level);
           n = _next[n];
         }
@@ -938,6 +938,6 @@
       for(typename ItemSetTraits<GR,Item>::ItemIt i(_graph);
           i != INVALID; ++i) {
-        _level[i] = _max_level;
-        _active[i] = false;
+        _level.set(i, _max_level);
+        _active.set(i, false);
       }
     }
@@ -945,14 +945,14 @@
     ///Add an item to the current level.
     void initAddItem(Item i) {
-      _level[i] = _init_level;
+      _level.set(i, _init_level);
       if (_last[_init_level] == INVALID) {
         _first[_init_level] = i;
         _last[_init_level] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[i] = _last[_init_level];
-        _next[i] = INVALID;
-        _next[_last[_init_level]] = i;
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(i, _last[_init_level]);
+        _next.set(i, INVALID);
+        _next.set(_last[_init_level], i);
         _last[_init_level] = i;
       }
Index: lemon/euler.h
===================================================================
--- lemon/euler.h	(revision 578)
+++ lemon/euler.h	(revision 550)
@@ -25,5 +25,5 @@
 #include <list>
 
-/// \ingroup graph_properties
+/// \ingroup graph_prop
 /// \file
 /// \brief Euler tour
@@ -37,5 +37,5 @@
   ///Euler iterator for digraphs.
 
-  /// \ingroup graph_properties
+  /// \ingroup graph_prop
   ///This iterator converts to the \c Arc type of the digraph and using
   ///operator ++, it provides an Euler tour of a \e directed
@@ -124,5 +124,5 @@
   ///Euler iterator for graphs.
 
-  /// \ingroup graph_properties
+  /// \ingroup graph_prop
   ///This iterator converts to the \c Arc (or \c Edge)
   ///type of the digraph and using
@@ -229,5 +229,5 @@
   ///Checks if the graph is Eulerian
 
-  /// \ingroup graph_properties
+  /// \ingroup graph_prop
   ///Checks if the graph is Eulerian. It works for both directed and undirected
   ///graphs.
